%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%define gobuild(o:) go build -tags="$BUILDTAGS rpm_crashtraceback" -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};

%global provider        github
%global provider_tld    com
%global project         cri-o
%global repo            cri-o
# https://github.com/kubernetes-sigs/cri-o
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}

Name:    conmon
%if 0%{?fedora}
Epoch: 2
%endif
Version: 1.14.7
Release: 1.0.9%{?dist}
Vendor:  Oracle America
Summary: OCI container runtime monitor
Epoch:   3
License: Apache-2.0
URL:     https://%{provider_prefix}
Source0: %{name}-%{version}.tar.bz2

ExcludeArch: ppc64
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires: %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
BuildRequires: golang >= 1.13.15
BuildRequires: btrfs-progs-devel
BuildRequires: git
BuildRequires: glib2-devel
BuildRequires: glibc-static
BuildRequires: go-md2man
BuildRequires: gpgme-devel
BuildRequires: libassuan-devel
BuildRequires: pkgconfig(systemd)
BuildRequires: device-mapper-devel
BuildRequires: make
BuildRequires: libseccomp-devel

%description
conmon is an OCI container runtime monitor.

%prep
%setup -q
sed -i '/strip/d' pause/Makefile

%build
mkdir _output
pushd _output
mkdir -p src/%{provider}.%{provider_tld}/{%{project},opencontainers}
ln -s $(dirs +1 -l) src/%{import_path}
popd

ln -s vendor src
export GOPATH=$(pwd)/_output:$(pwd):%{gopath}
export BUILDTAGS="selinux seccomp $(hack/btrfs_installed_tag.sh) $(hack/btrfs_tag.sh) $(hack/libdm_installed.sh) containers_image_ostree_stub"

BUILDTAGS=$BUILDTAGS make bin/conmon

%install
# install binaries
install -dp %{buildroot}{%{_bindir},%{_libexecdir}/crio}
install -p -m 755 bin/conmon %{buildroot}%{_libexecdir}/crio
# Latest version of podman expecting conman at different location
ln -sf %{_libexecdir}/crio/%{name} %{buildroot}%{_bindir}/%{name}

%files
%license LICENSE THIRD_PARTY_LICENSES.txt
%doc README.md
%{_libexecdir}/crio/conmon
%{_bindir}/%{name}

%changelog
* Thu Nov 12 2020 Tom Cocozzello <tom.cocozzello@oracle.com> - 1.14.7-1.0.9
- Define a epoch
- Add symlink for conmon under bin dir to satisfy latest podman

* Fri Aug 14 2020 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.14.7-1.0.8
- Address CVE-2020-16845

* Fri Feb 28 2020 Tom Cocozzello <tom.cocozzello@oracle.com> - 1.14.7-1.0.7
- Enhance versioning detection

* Wed Jan 15 2020 Daniel Krasinski <daniel.krasinski@oracle.com> - 1.14.7-1.0.6
- added explicit dependency on cri-tools

* Wed Oct 30 2019 Daniel Krasinski <daniel.krasinski@oracle.com> - 1.14.7-1.0.5
- feature OCR forward

* Tue Oct 15 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.14.7-1.0.4
- Golang CVE-2019-16276

* Fri Oct 11 2019 Durai G <durai.vattakalvalasu.govindas@oracle.com> - 1.14.7-1.0.3
- added THIRD_PARTY_LICENSES.txt file

* Mon Aug 19 2019 Michael Calunod  <michael.calunod@oracle.com> - 1.14.7-1.0.2
- moved to semantic versioning for Release

* Sun Jul 14 2019 Olcne-Builder Jenkins <olcne-builder_us@oracle.com> - 1.14.7-1
- Added Oracle Specifile Files for cri-o
